<?php
/*
** This file illustrates a possible use for the scrips si.php and
** sl.php. It also exemplifies how to generate a registry editor
** file with the settings of a player and j2i files.
**********************************************************
*/
$re = '<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head><link href="normal.css" title="Dark blue on light background" rel="stylesheet" />
<link rel="alternate stylesheet" title="White on black, black on blue" href="black&amp;blue.css" />';

$foot = '<div style="margin-top: 1em;"><a href="http://validator.w3.org/check/referer"><img src="http://www.w3.org/Icons/valid-xhtml10"
alt="Valid XHTML 1.0!" style="border:0;width:59px;height:21px" /></a>
<a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:59px;height:21px"
src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!" /></a></div>
<hr id="hr2" />'.$_SERVER['SERVER_SIGNATURE']."</body></html>";

function remgar($v) {
	while (($n = strpos($v,"")) !== FALSE) { 
		$v = substr($v,0,$n).substr($v,$n +2);
	}
	$v = str_replace("|","",$v);
	return $v;
}

if (!isset($_GET['si'])) {
  echo $re;
  echo '<title>Jazz 2 Server List</title></head><body>
  <h1 id="header">Jazz2 Server List</h1><hr id="hr1" />
  <div id="div1"><table id="serverlist" cellspacing="0">
  <tr class="head"><td class="servername">Server Name</td>
  <td class="type">Game Type</td>
  <td class="players">Occupation</td>
  <td class="version">Version</td>
  <td class="ip">Server Type</td>
  <td class="uptime">Uptime</td>
  </tr>';
  include("sl.php");
  $verre = array("1.24s","1.21s","1.20s","1.24x","1.24","1.21","1.20");
  $sub = array("4","1","0","none","4","1","0");
  for ($r = 0;$r < count($sl_servers);$r++) { $obj = $sl_servers[$r];
    //version substitution
    $lik = str_replace($verre,$sub,$obj->getversion());
    $ip2 = $obj->getip();
	$players = $obj->getplayers(TRUE);
    if ($players == "0/0") $players = "??";

    $c = '';
	echo '<tr><td class="servername">';
	if ($obj->gettype() != "private") { echo '<a title="Join Server"
	href="'.$_SERVER['PHP_SELF']."?si=3&amp;version=$lik&amp;
	ip=".$obj->getip().'">'; $c = "</a>"; }
	echo $obj->getname(TRUE)."$c</td>
    <td class=\"type\">".$obj->getgamemode()."</td><td class=\"players\">
    $players</td><td class=\"version\">".$obj->getversion()."</td>
    <td class=\"ip\">".$obj->gettype()."</td>
	<td class=\"uptime\">".$obj->getuptime()."</td>";
    if ((strlen($lik) == 1) && ($obj->gettype() != "private")) echo "
    <td class=\"extra\"><a href=\"".$_SERVER['PHP_SELF']."?si=1&amp;ip=".$obj->getip()."&amp;version=$lik&amp;name=".urlencode($obj->getname(TRUE))."\">
    Details</a></td>";
    else echo "<td class=\"extrade\">Details</td>";
    echo "</tr>";
  }
  echo "\n</table>\n";
  if ($sl_errno != 0) {
    if ($sl_errno == 10060)
	  echo "<p class=\"error\"><br />The server appears to be down.</p></div>".$foot;
	else echo "<p class=\"error\"><br />An error has ocurred: $sl_errstr</p></div>".$foot;
   }
  else echo "<p>There are currently <b>$sl_servers_number</b> game(s) listed.<br />
  The total server occupation is <b>$sl_total_players/$sl_total_capacity</b>.</p>
  </div>".$foot;
}

elseif (@$_GET['si'] == 1) {
  if ((!isset($_GET['name'])) || (!isset($_GET['ip'])) || (!isset($_GET['version']))) die("Insufficient parameters");
  echo $re;
  echo '<title>Jazz2 Server Details</title></head><body>
  <h2 id="header">Details for <i>'.urldecode(stripslashes($_GET['name'])).'</i></h2><hr id="hr1" />
  <div id="div2">
  <div id="div3">
  <table id="levelname" cellspacing="0">
  ';
  include("si.php");
  echo '<tr class="head"><td id="ln1">Level Filename</td></tr><tr><td class="levelname">'.$si_levelname.'</td></tr>
  </table>
  </div>
  <div id="div4">
  <table id="pllist" cellspacing="0">
  <tr class="head"><td class="num">&#35;</td><td class="char">Char</td><td class="name">Name
  </td><td class="colors">Colors</td></tr>';

  for ($r = 0;$r < count($si_players);$r++) { $obj = $si_players[$r];
    echo "<tr><td class=\"num\">".$obj->getnumber()."</td>
    <td class=\"char\">".$obj->getchar()."</td>
    <td class=\"name\">".htmlspecialchars($obj->getname(TRUE))."</td>
    <td class=\"colors\">".$obj->getcolors()."</td>
    <td class=\"extra\"><a href=\"".$_SERVER['PHP_SELF'].
    "?si=2&amp;char=".$obj->getchar()."&amp;nome=".urlencode($obj->getname(FALSE)).
    "&amp;pelo=".urlencode($obj->getcolors())."&amp;version=$si_version\">Save</a></td></tr>";
  }

  echo "</table></div>";
  if ($si_errno == 10060) echo "<p class=\"error\"><br />The server appears to be down.</p>";
  elseif ($si_errno == -2) echo '<p><br />The server has sent an unexpected response. This
  situation may have happened because:</p><ul id="unresp">
  <li>The server is full;</li>
  <li>this webserver is banned;</li>
  <li>the server has its version erroneously listed;</li>
  <li>other.</li></ul>';
  elseif ($si_errno != 0) echo
    "<p class=\"error\"><br />An error has ocurred: $si_errstr</p></div>";
  else echo "<p><br />This server has <b>".$si_number_players."</b> player(s).</p>";

  echo "</div>".$foot;
}

elseif (@$_GET['si'] == 2) {
	if ((!isset($_GET['char'])) || (!isset($_GET['nome'])) || (!isset($_GET['pelo'])) || (!isset($_GET['version']))) {
	die("Insufficient parameters"); }
	$v = $_GET['version']; $c = $_GET['char'];
	$nome = urldecode(stripslashes($_GET['nome']));
	if (($v != 0) && ($v != 1) &&  ($v != 4)) die("Unsupported version");
	header('Content-Disposition: attachment; filename="'.remgar($nome).".reg\"\r\n");
	header('Content-Type: application/octet-stream; name="'.$nome.".reg\"\r\n");
	if ($v != 4) {
		if ($c == "Spaz") $cnum = 55;
		else $cnum = 36;
	}
	else {
		if ($c == "Spaz") $cnum = 59;
		elseif ($c == "Lori") $cnum = "3D";
		else $cnum = 37;
	}
	$a = split(" ",urldecode($_GET['pelo']));
	$hnum = dechex($a[0]).",".dechex($a[1]).",".dechex($a[2]).",".dechex($a[3]);
	echo 'Windows Registry Editor Version 5.00
';
	if ($v != 4) echo '[HKEY_CURRENT_USER\Software\Epic MegaGames\Jazz Jackrabbit 2\1.2'.($v==1?3:$v).'\Player0]
';
	else echo '[HKEY_CURRENT_USER\Software\Epic MegaGames\Jazz Jackrabbit 2 Special Edition\1.24\Player0]
';
	echo '"Name"="'.$nome.'"
"Char"=hex:'.$cnum.',00,00,00
"Color"=hex:'.$hnum."\r\n\r\n";
}
elseif (@$_GET['si'] == 3) {
	if ((!isset($_GET['ip'])) || (!isset($_GET['version'])))
		die("Insufficient parameters");
	$ext = str_replace(array("0","1","4"),array("j2oi","j2i","j2si"),$_GET['version']);
	$formato = 'Content-Disposition: attachment; filename="jazz2.%s"';
	header(sprintf($formato,$ext));
	header('Content-Type: application/x-jazz2');
	echo $_GET['ip'].":10052";
}
?>